(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('base-foundation'), require('@totvs/thf-ui/components/thf-modal/thf-modal.component'), require('@angular/core'), require('@totvs/thf-ui'), require('@angular/common'), require('@totvs/thf-ui/services/thf-notification/thf-notification.service'), require('@totvs/thf-ui/services/thf-notification/thf-toaster/thf-toaster-orientation.enum'), require('@angular/common/http'), require('rxjs'), require('rxjs/operators'), require('@totvs/thf-ui/services/thf-i18n'), require('@totvs/thf-ui/services/thf-i18n/thf-i18n-config-injection-token'), require('@totvs/thf-ui/services/thf-i18n/thf-i18n.service'), require('@angular/router')) :
	typeof define === 'function' && define.amd ? define(['exports', 'base-foundation', '@totvs/thf-ui/components/thf-modal/thf-modal.component', '@angular/core', '@totvs/thf-ui', '@angular/common', '@totvs/thf-ui/services/thf-notification/thf-notification.service', '@totvs/thf-ui/services/thf-notification/thf-toaster/thf-toaster-orientation.enum', '@angular/common/http', 'rxjs', 'rxjs/operators', '@totvs/thf-ui/services/thf-i18n', '@totvs/thf-ui/services/thf-i18n/thf-i18n-config-injection-token', '@totvs/thf-ui/services/thf-i18n/thf-i18n.service', '@angular/router'], factory) :
	(factory((global['checklist-web-foundation'] = {}),global.baseFoundation,global.thfModal_component,global.core,global.thfUi,global.common,global.thfNotification_service,global.thfToasterOrientation_enum,global.http,global.rxjs,global.operators,global.thfI18n,global.thfI18nConfigInjectionToken,global.thfI18n_service,global.router));
}(this, (function (exports,baseFoundation,thfModal_component,core,thfUi,common,thfNotification_service,thfToasterOrientation_enum,http,rxjs,operators,thfI18n,thfI18nConfigInjectionToken,thfI18n_service,router) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Classe/componente de mensagem
 */
var MessageComponent = /** @class */ (function () {
    function MessageComponent() {
        /**
         * Atributo com o título da mensagem
         */
        this.messageTitle = '';
        /**
         * Atributo com o texto da mensagem
         */
        this.messageText = '';
        /**
         * Atributo com os detalhes da mensagem
         */
        this.messageDetails = '';
        /**
         * Atributo que recebe a ação de confirmação
         */
        this.messageConfirmAction = undefined;
        /**
         * Atributo que recebe a ação de cancelamento
         */
        this.messageCancelAction = undefined;
        /**
         * Atributo que recebe o tipo do link
         */
        this.messageLinkActionType = baseFoundation.ShowMessageLinkActionType.No;
        /**
         * Atributo que recebe o link
         */
        this.messageLinkAction = undefined;
        /**
         * Atributo que recebe o label do link
         */
        this.messageLinkLabel = '';
        /**
         * Atributo que indica se os detalhes da mensagem devem ser escondidos
         */
        this.hideDetails = true;
    }
    /**
     * Método responsável por disparar a abertura da dialog
     */
    /**
     * Método responsável por disparar a abertura da dialog
     * @return {?}
     */
    MessageComponent.prototype.openDialog = /**
     * Método responsável por disparar a abertura da dialog
     * @return {?}
     */
    function () {
        this.thfModal.open();
    };
    /**
     * Método responsável por fechar a dialog
     */
    /**
     * Método responsável por fechar a dialog
     * @return {?}
     */
    MessageComponent.prototype.closeDialog = /**
     * Método responsável por fechar a dialog
     * @return {?}
     */
    function () {
        this.thfModal.close();
    };
    /**
     * Método responsável por executar ação do link relacionado a mensagem
     */
    /**
     * Método responsável por executar ação do link relacionado a mensagem
     * @return {?}
     */
    MessageComponent.prototype.linkAction = /**
     * Método responsável por executar ação do link relacionado a mensagem
     * @return {?}
     */
    function () {
        this.messageLinkAction();
    };
    MessageComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'app-message',
                    template: "<thf-modal [t-title]=\"messageTitle\" [t-primary-action]=\"messageConfirmAction\" [t-secondary-action]=\"messageCancelAction\"> <div class=\"message-body\"> {{messageText}} <p *ngIf=\"messageLinkActionType\"> <a href=\"javascript:void(0)\" (click)=\"linkAction()\">{{messageLinkLabel}}</a> </p> <br/> <div *ngIf=\"messageDetails\" class=\"message-details\"> <a *ngIf=\"hideDetails\" class=\"show-details\" href=\"javascript:void(0);\" (click)=\"hideDetails = !hideDetails\"> <span class=\"thf-icon thf-icon-arrow-down\"></span> Exibir detalhes </a> <a *ngIf=\"!hideDetails\" class=\"show-details\" href=\"javascript:void(0);\" (click)=\"hideDetails = !hideDetails\"> <span class=\"thf-icon thf-icon-arrow-up\"></span> Ocultar detalhes </a> <p [ngClass]=\"{'hide-details': hideDetails}\"> {{messageDetails}} </p> </div>     </div> </thf-modal>",
                    styles: [".show-details { height: 12px; font-family: 'NunitoSans-Bold'; font-size: 14px !important; line-height: 1.71; text-align: left; color: #1d9abc; padding-top: 13px; padding-bottom: 15px; text-decoration: none; } .hide-details { display: none; } .message-body { overflow: hidden; margin-bottom: 4px; margin-left: 10px; vertical-align: top; min-height: 45px; } .message-details { margin-top: 15px; text-align: center; border-top: solid 1px #dbdedf; }"]
                },] },
    ];
    MessageComponent.propDecorators = {
        thfModal: [{ type: core.ViewChild, args: [thfModal_component.ThfModalComponent,] }]
    };
    return MessageComponent;
}());

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço de mensagens
 */
var MessageService = /** @class */ (function (_super) {
    __extends(MessageService, _super);
    /**
     * Método construtor da classe
     * @param thfNotification Parâmetro do serviço de notificação do THF
     * @param componentFactoryResolver Parâmetro do serviço que permite adicionar componentes dinamicamente
     * @param appRef Parâmetro que recebe a referência da aplicação Angular.
     * @param injector Parâmetro do serviço de injeção de dependência
     * @param i18n  Parâmetro do serviço de internacionalização
     */
    function MessageService(thfNotification, componentFactoryResolver, appRef, injector, i18n) {
        var _this = _super.call(this) || this;
        _this.thfNotification = thfNotification;
        _this.componentFactoryResolver = componentFactoryResolver;
        _this.appRef = appRef;
        _this.injector = injector;
        _this.i18n = i18n;
        /**
         * Atributo que recebe a instância da dialog criada
         */
        _this.messageDialogRef = undefined;
        return _this;
    }
    /**
     * Método responsável por exibir uma mensagem, através de notificação ou dialog
     * @param showMessageOptions Parâmetro com as definições da mensagem
     */
    /**
     * Método responsável por exibir uma mensagem, através de notificação ou dialog
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    MessageService.prototype.displayMessage = /**
     * Método responsável por exibir uma mensagem, através de notificação ou dialog
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    function (showMessageOptions) {
        showMessageOptions = showMessageOptions;
        switch (showMessageOptions.messageType) {
            case baseFoundation.ShowMessageType.NotificationError:
            case baseFoundation.ShowMessageType.NotificationInformation:
            case baseFoundation.ShowMessageType.NotificationSuccess:
            case baseFoundation.ShowMessageType.NotificationWarning:
                this.showNotification(showMessageOptions);
                break;
            case baseFoundation.ShowMessageType.DialogAlert:
            case baseFoundation.ShowMessageType.DialogConfirmation:
                this.showDialog(showMessageOptions);
                break;
            default:
                throw new Error("Tipo de mensagem inv\u00E1lido: " + showMessageOptions.messageType);
        }
    };
    /**
     * Método responsável por exibir uma notificação em tela
     * @param showMessageOptions Parâmetro com as definições da mensagem
     */
    /**
     * Método responsável por exibir uma notificação em tela
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    MessageService.prototype.showNotification = /**
     * Método responsável por exibir uma notificação em tela
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    function (showMessageOptions) {
        /** @type {?} */
        var thfNotification = {
            message: showMessageOptions.messageText,
            orientation: thfToasterOrientation_enum.ThfToasterOrientation.Top,
            action: this.processLinkAction(showMessageOptions),
            actionLabel: showMessageOptions.messageLinkLabel
        };
        switch (showMessageOptions.messageType) {
            case baseFoundation.ShowMessageType.NotificationSuccess:
                this.thfNotification.success(thfNotification);
                break;
            case baseFoundation.ShowMessageType.NotificationError:
                this.thfNotification.error(thfNotification);
                break;
            case baseFoundation.ShowMessageType.NotificationInformation:
                this.thfNotification.information(thfNotification);
                break;
            case baseFoundation.ShowMessageType.NotificationWarning:
                this.thfNotification.warning(thfNotification);
                break;
        }
    };
    /**
     * Método por exibir uma dialog em tela
     * @param showMessageOptions Parâmetro com as definições da mensagem
     */
    /**
     * Método por exibir uma dialog em tela
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    MessageService.prototype.showDialog = /**
     * Método por exibir uma dialog em tela
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    function (showMessageOptions) {
        this.createDialogComponent();
        this.setDialogOptions(showMessageOptions);
        this.messageDialogRef.instance.openDialog();
    };
    /**
     * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
     * @param link Link de uma página externa
     */
    /**
     * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
     * @private
     * @param {?} link Link de uma página externa
     * @return {?}
     */
    MessageService.prototype.openLink = /**
     * Método responsável por abrir no navegador uma nova tab com o link recebido por parâmetro
     * @private
     * @param {?} link Link de uma página externa
     * @return {?}
     */
    function (link) {
        link = link.indexOf('http://') === -1 ? "http://" + link : link;
        window.open(link, '_blank');
    };
    /**
     * Método responsável por identificar se o link recebido é uma função ou página externa
     * @param showMessageOptions Parâmetro com as definições da mensagem
     */
    /**
     * Método responsável por identificar se o link recebido é uma função ou página externa
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    MessageService.prototype.processLinkAction = /**
     * Método responsável por identificar se o link recebido é uma função ou página externa
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    function (showMessageOptions) {
        var _this = this;
        /** @type {?} */
        var action = undefined;
        if (showMessageOptions.messageLinkActionType === baseFoundation.ShowMessageLinkActionType.Method) {
            action = showMessageOptions.messageLinkAction;
        }
        else if (showMessageOptions.messageLinkActionType === baseFoundation.ShowMessageLinkActionType.LinkNewTab &&
            showMessageOptions.messageLinkAction && showMessageOptions.messageLinkAction.trim() !== '') {
            action = (/**
             * @return {?}
             */
            function () {
                _this.openLink(showMessageOptions.messageLinkAction);
            });
        }
        return action;
    };
    /**
     * Método responsável por criar o componente dialog
     */
    /**
     * Método responsável por criar o componente dialog
     * @private
     * @return {?}
     */
    MessageService.prototype.createDialogComponent = /**
     * Método responsável por criar o componente dialog
     * @private
     * @return {?}
     */
    function () {
        if (this.messageDialogRef === undefined) {
            this.messageDialogRef = this.componentFactoryResolver
                .resolveComponentFactory(MessageComponent)
                .create(this.injector);
            this.appRef.attachView(this.messageDialogRef.hostView);
            /** @type {?} */
            var domElem = (/** @type {?} */ (((/** @type {?} */ (this.messageDialogRef.hostView)))
                .rootNodes[0]));
            document.body.appendChild(domElem);
        }
    };
    /**
     * Método responsável por setar as opções do componente dialog
     * @param showMessageOptions Parâmetro com as definições da mensagem
     */
    /**
     * Método responsável por setar as opções do componente dialog
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    MessageService.prototype.setDialogOptions = /**
     * Método responsável por setar as opções do componente dialog
     * @private
     * @param {?} showMessageOptions Parâmetro com as definições da mensagem
     * @return {?}
     */
    function (showMessageOptions) {
        var _this = this;
        if (showMessageOptions.messageTitle !== undefined &&
            showMessageOptions.messageTitle.trim() !== '') {
            this.messageDialogRef.instance.messageTitle = showMessageOptions.messageTitle;
        }
        else if (showMessageOptions.messageType === baseFoundation.ShowMessageType.DialogAlert) {
            this.messageDialogRef.instance.messageTitle = this.i18n.literals['warning'];
        }
        else if (showMessageOptions.messageType === baseFoundation.ShowMessageType.DialogConfirmation) {
            this.messageDialogRef.instance.messageTitle = this.i18n.literals['confirm'];
        }
        this.messageDialogRef.instance.messageText = showMessageOptions.messageText;
        this.messageDialogRef.instance.messageDetails = showMessageOptions.messageDetails;
        this.messageDialogRef.instance.messageConfirmAction = {
            action: (/**
             * @return {?}
             */
            function () {
                if (showMessageOptions.messageConfirmAction) {
                    showMessageOptions.messageConfirmAction();
                }
                _this.messageDialogRef.instance.closeDialog();
            }),
            label: showMessageOptions.messageConfirmLabel
        };
        this.messageDialogRef.instance.messageCancelAction = {
            action: (/**
             * @return {?}
             */
            function () {
                if (showMessageOptions.messageCancelAction) {
                    showMessageOptions.messageCancelAction();
                }
                _this.messageDialogRef.instance.closeDialog();
            }),
            label: showMessageOptions.messageCancelLabel
        };
        this.messageDialogRef.instance.messageLinkActionType = showMessageOptions.messageLinkActionType;
        if (showMessageOptions.messageLinkActionType === baseFoundation.ShowMessageLinkActionType.LinkNewTab) {
            /** @type {?} */
            var link_1 = showMessageOptions.messageLinkAction;
            showMessageOptions.messageLinkAction = (/**
             * @return {?}
             */
            function () {
                _this.openLink(link_1);
            });
        }
        this.messageDialogRef.instance.messageLinkAction = showMessageOptions.messageLinkAction;
        this.messageDialogRef.instance.messageLinkLabel = showMessageOptions.messageLinkLabel;
    };
    MessageService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    MessageService.ctorParameters = function () { return [
        { type: thfNotification_service.ThfNotificationService },
        { type: core.ComponentFactoryResolver },
        { type: core.ApplicationRef },
        { type: core.Injector },
        { type: baseFoundation.I18nBaseService }
    ]; };
    return MessageService;
}(baseFoundation.AbstractShowMessage));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MessageModule = /** @class */ (function () {
    function MessageModule() {
    }
    MessageModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [MessageComponent],
                    imports: [
                        common.CommonModule,
                        thfUi.ThfModule
                    ],
                    exports: [],
                    providers: [
                        MessageService,
                        baseFoundation.MessageDisplayerService,
                        {
                            provide: baseFoundation.AbstractShowMessage,
                            useClass: MessageService
                        }
                    ]
                },] },
    ];
    return MessageModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço que realiza o carregamento das literais do serviço de internacionalização
 */
var IntlLiteralsLoaderService = /** @class */ (function () {
    /**
     * Método construtor da classe
     * @param http Parâmetro do serviço de Http
     * @param thfI18nService Parâmetro do serviço de internacionalização do THF
     */
    function IntlLiteralsLoaderService(http$$1, thfI18nService) {
        this.http = http$$1;
        this.thfI18nService = thfI18nService;
        /**
         * Atributo com opções de internacionalização Web
         */
        this.webOptions = { context: '', language: '', url: '' };
    }
    /**
     * Método responsável por alterar as opções para carregamento de literais
     * @param options Parâmetro com as opções de internacionalização (url, language, context)
     */
    /**
     * Método responsável por alterar as opções para carregamento de literais
     * @param {?} options Parâmetro com as opções de internacionalização (url, language, context)
     * @return {?}
     */
    IntlLiteralsLoaderService.prototype.updateOptions = /**
     * Método responsável por alterar as opções para carregamento de literais
     * @param {?} options Parâmetro com as opções de internacionalização (url, language, context)
     * @return {?}
     */
    function (options) {
        var _this = this;
        /** @type {?} */
        var obs = new rxjs.Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            if (_this.optionsWasChanged(options)) {
                Object.assign(_this.webOptions, options);
                _this.load().subscribe((/**
                 * @param {?} x
                 * @return {?}
                 */
                function (x) {
                    _this.cache = x;
                    observer.next(_this.cache);
                }));
            }
            else if (_this.cache) {
                observer.next(_this.cache);
            }
        }));
        return obs;
    };
    /**
     * Método responsável por realizar o carregamento inicial das literais
     */
    /**
     * Método responsável por realizar o carregamento inicial das literais
     * @return {?}
     */
    IntlLiteralsLoaderService.prototype.load = /**
     * Método responsável por realizar o carregamento inicial das literais
     * @return {?}
     */
    function () {
        var _this = this;
        return this.http.get(this.webOptions.url)
            .pipe(operators.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            /** @type {?} */
            var s = (/** @type {?} */ (_this.thfI18nService));
            s.config.contexts[_this.webOptions.context] = res;
            s.setVarI18n(s.config.contexts);
            return res;
        })), operators.mergeMap((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return _this.updateLiteralsFromThfContext(); })), operators.catchError((/**
         * @param {?} e
         * @param {?} caught
         * @return {?}
         */
        function (e, caught) { return caught; })));
    };
    /**
     * Detecta se ocorreram mudanças na configuração
     */
    /**
     * Detecta se ocorreram mudanças na configuração
     * @private
     * @param {?} options
     * @return {?}
     */
    IntlLiteralsLoaderService.prototype.optionsWasChanged = /**
     * Detecta se ocorreram mudanças na configuração
     * @private
     * @param {?} options
     * @return {?}
     */
    function (options) {
        return this.webOptions.context !== options.context
            || this.webOptions.url !== options.url
            || this.webOptions.language !== options.language;
    };
    /**
     * Método responsável por carregar as literais do contexto do THF
     */
    /**
     * Método responsável por carregar as literais do contexto do THF
     * @private
     * @return {?}
     */
    IntlLiteralsLoaderService.prototype.updateLiteralsFromThfContext = /**
     * Método responsável por carregar as literais do contexto do THF
     * @private
     * @return {?}
     */
    function () {
        return this.thfI18nService.getLiterals({
            context: this.webOptions.context,
            language: this.webOptions.language
        }).pipe(operators.map((/**
         * @param {?} res
         * @return {?}
         */
        function (res) { return res; })));
    };
    IntlLiteralsLoaderService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    IntlLiteralsLoaderService.ctorParameters = function () { return [
        { type: http.HttpClient },
        { type: thfI18n.ThfI18nService }
    ]; };
    return IntlLiteralsLoaderService;
}());

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Token de configuração da url de internacionalização
 * @type {?}
 */
var INTL_CONFIG = new core.InjectionToken('Configurações da internacionalização');
/**
 * Serviço de internacionalização
 */
var IntlService = /** @class */ (function (_super) {
    __extends$1(IntlService, _super);
    /**
     * Método construtor da classe
     * @param config Parâmetro do serviço com as configurações de internacionalização
     * @param intlLiteralsLoader Parâmetro do serviço de carregamento de literais de internacionalização
     */
    function IntlService(config, intlLiteralsLoader) {
        var _this = _super.call(this, intlLiteralsLoader) || this;
        /** @type {?} */
        var matchedNavigatorAppLanguage;
        if (config.supportedLanguages) {
            matchedNavigatorAppLanguage = config.supportedLanguages.find((/**
             * @param {?} appSupportedLanguage
             * @return {?}
             */
            function (appSupportedLanguage) {
                return appSupportedLanguage.language === navigator.language;
            }));
        }
        /** @type {?} */
        var setLanguage = _this.updateOptions({
            context: IntlService.i18nConfig.default.context,
            language: matchedNavigatorAppLanguage ? matchedNavigatorAppLanguage.language : IntlService.i18nConfig.default.language,
            url: config.url
        });
        if (config.lazy === undefined || config.lazy === false) {
            setLanguage.subscribe();
        }
        return _this;
    }
    /**
     * Atributo com as configurações de internacionalização
     */
    IntlService.i18nConfig = {
        contexts: {},
        default: {
            language: 'pt-br',
            context: 'general',
            cache: true
        }
    };
    IntlService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    IntlService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [INTL_CONFIG,] }] },
        { type: IntlLiteralsLoaderService }
    ]; };
    return IntlService;
}(baseFoundation.I18nBaseService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ɵ0 = IntlService.i18nConfig;
var ɵ1 = thfI18n_service.returnThfI18nService;
var IntlModule = /** @class */ (function () {
    function IntlModule() {
    }
    IntlModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                    // ThfI18nModule.config(IntlService.i18nConfig)
                    ],
                    exports: [
                        thfI18n.ThfI18nModule
                    ],
                    providers: [
                        IntlService,
                        IntlLiteralsLoaderService,
                        {
                            provide: baseFoundation.I18nBaseService,
                            useClass: IntlService
                        },
                        {
                            provide: thfI18nConfigInjectionToken.I18N_CONFIG,
                            useValue: ɵ0
                        },
                        {
                            provide: thfI18n.ThfI18nService,
                            useFactory: ɵ1,
                            deps: [thfI18nConfigInjectionToken.I18N_CONFIG, http.HttpClient]
                        }
                    ]
                },] },
    ];
    return IntlModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingComponent = /** @class */ (function () {
    function LoadingComponent() {
        /**
         * Texto do loading
         */
        this.text = '';
        /**
         * Definine se será bloqueada a tela inteira ou apenas o container em que o componente de loading está inserido
         */
        this.screenLock = false;
        /**
         * Define se o loading está sendo mostrado ou não
         */
        this.show = false;
    }
    /**
     * Permite atribuir o texto do loading
     */
    /**
     * Permite atribuir o texto do loading
     * @param {?=} text
     * @return {?}
     */
    LoadingComponent.prototype.setLoadingText = /**
     * Permite atribuir o texto do loading
     * @param {?=} text
     * @return {?}
     */
    function (text) {
        if (text === void 0) { text = ''; }
        this.text = text;
    };
    /**
     * Apresenta o loading, bloqueando a tela
     */
    /**
     * Apresenta o loading, bloqueando a tela
     * @return {?}
     */
    LoadingComponent.prototype.showLoading = /**
     * Apresenta o loading, bloqueando a tela
     * @return {?}
     */
    function () {
        this.show = true;
    };
    /**
     * Esconde o loading, desbloqueando a tela
     */
    /**
     * Esconde o loading, desbloqueando a tela
     * @return {?}
     */
    LoadingComponent.prototype.hideLoading = /**
     * Esconde o loading, desbloqueando a tela
     * @return {?}
     */
    function () {
        this.show = false;
    };
    LoadingComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'app-loading',
                    template: "<thf-loading-overlay *ngIf=\"show\" [t-screen-lock]=\"screenLock\" [t-text]=\"text\"> </thf-loading-overlay>",
                    styles: [""]
                },] },
    ];
    return LoadingComponent;
}());

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingService = /** @class */ (function (_super) {
    __extends$2(LoadingService, _super);
    /**
     * Construtor do serviço
     * @param i18n Serviço de internacionalização
     * @param componentFactoryResolver Serviço que permite adicionar componentes dinamicamente
     * @param appRef Referência da aplicação Angular
     * @param injector Serviço de injeção de dependência
     */
    function LoadingService(i18n, componentFactoryResolver, appRef, injector) {
        var _this = _super.call(this) || this;
        _this.i18n = i18n;
        _this.componentFactoryResolver = componentFactoryResolver;
        _this.appRef = appRef;
        _this.injector = injector;
        /**
         * Referência para o componente de loading no html
         */
        _this.loadingComponentRef = undefined;
        /**
         * Texto apresentado durante o loading
         */
        _this.loadingText = '';
        return _this;
    }
    /**
     * Exibe o loading, bloqueando a tela
     */
    /**
     * Exibe o loading, bloqueando a tela
     * @return {?}
     */
    LoadingService.prototype.showLoading = /**
     * Exibe o loading, bloqueando a tela
     * @return {?}
     */
    function () {
        if (this.loadingComponentRef === undefined) {
            this.createLoadingComponent();
        }
        this.loadingComponentRef.instance.showLoading();
    };
    /**
     * Esconde o loading, desbloqueando a tela
     */
    /**
     * Esconde o loading, desbloqueando a tela
     * @return {?}
     */
    LoadingService.prototype.hideLoading = /**
     * Esconde o loading, desbloqueando a tela
     * @return {?}
     */
    function () {
        if (this.loadingComponentRef !== undefined) {
            this.loadingComponentRef.instance.hideLoading();
        }
    };
    /**
     * Atribui o texto que será apresentado
     * @param text Texto a ser apresentado, devendo ser um BaseMessage
     */
    /**
     * Atribui o texto que será apresentado
     * @param {?} text Texto a ser apresentado, devendo ser um BaseMessage
     * @return {?}
     */
    LoadingService.prototype.setLoadingText = /**
     * Atribui o texto que será apresentado
     * @param {?} text Texto a ser apresentado, devendo ser um BaseMessage
     * @return {?}
     */
    function (text) {
        this.loadingText = this.i18n.text(text) ? this.i18n.text(text).text : '';
        if (this.loadingComponentRef === undefined) {
            this.createLoadingComponent();
        }
        this.loadingComponentRef.instance.text = this.loadingText;
    };
    /**
     * Método privado que cria dinamicamente o componente de loading no DOM
     */
    /**
     * Método privado que cria dinamicamente o componente de loading no DOM
     * @private
     * @return {?}
     */
    LoadingService.prototype.createLoadingComponent = /**
     * Método privado que cria dinamicamente o componente de loading no DOM
     * @private
     * @return {?}
     */
    function () {
        if (this.loadingComponentRef === undefined) {
            this.loadingComponentRef = this.componentFactoryResolver
                .resolveComponentFactory(LoadingComponent)
                .create(this.injector);
            this.appRef.attachView(this.loadingComponentRef.hostView);
            /** @type {?} */
            var domElem = (/** @type {?} */ (((/** @type {?} */ (this.loadingComponentRef.hostView)))
                .rootNodes[0]));
            document.body.appendChild(domElem);
        }
    };
    LoadingService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    LoadingService.ctorParameters = function () { return [
        { type: baseFoundation.I18nBaseService },
        { type: core.ComponentFactoryResolver },
        { type: core.ApplicationRef },
        { type: core.Injector }
    ]; };
    return LoadingService;
}(baseFoundation.LoadingDefault));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Serviço responsável por métodos e atributos utilizados por toda aplicação web
 */
var GlobalService = /** @class */ (function () {
    /**
     * Método construtor que inicializa a classe
     * @param i18n Parâmetro do serviço de internacionalização
     * @param msg  Parâmetro do serviço de mensagens
     * @param loading Parâmetro do serviço de loading
     */
    function GlobalService(i18n, msg, loading) {
        this.i18n = i18n;
        this.msg = msg;
        this.loading = loading;
    }
    GlobalService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    GlobalService.ctorParameters = function () { return [
        { type: baseFoundation.I18nBaseService },
        { type: baseFoundation.MessageDisplayerService },
        { type: LoadingService }
    ]; };
    return GlobalService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DateTimeModule = /** @class */ (function () {
    function DateTimeModule() {
    }
    DateTimeModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        baseFoundation.DateTimePipe,
                        baseFoundation.TimePipe
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        baseFoundation.DateTimePipe,
                        common.DatePipe
                    ],
                    providers: [
                        common.DatePipe,
                        baseFoundation.DateTimePipe,
                        baseFoundation.DefaultDateViewConverterService,
                        {
                            provide: baseFoundation.DateViewConverter,
                            useClass: baseFoundation.DefaultDateViewConverterService
                        },
                        baseFoundation.TimePipe,
                        baseFoundation.DefaultTimeViewConverterService,
                        {
                            provide: baseFoundation.TimeViewConverter,
                            useClass: baseFoundation.DefaultTimeViewConverterService
                        }
                    ]
                },] },
    ];
    return DateTimeModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var LoadingModule = /** @class */ (function () {
    function LoadingModule() {
    }
    LoadingModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [LoadingComponent],
                    imports: [
                        common.CommonModule,
                        thfUi.ThfModule
                    ],
                    exports: [],
                    providers: [
                        LoadingService
                    ]
                },] },
    ];
    return LoadingModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Módulo que exporta e ativas as dependências basicas do foundation
 * Para garantir que os serviços tenham uma única instância, usar FndModule.forRoot() ao importar
 * @export
 */
var FndModule = /** @class */ (function () {
    function FndModule() {
    }
    /**
     * @return {?}
     */
    FndModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: FndModule,
            providers: [
                GlobalService
            ]
        };
    };
    FndModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        thfUi.ThfModule,
                        IntlModule,
                        MessageModule,
                        DateTimeModule,
                        LoadingModule
                    ],
                    exports: [
                        thfUi.ThfModule,
                        IntlModule,
                        MessageModule,
                        DateTimeModule,
                        LoadingModule
                    ],
                    entryComponents: [MessageComponent, LoadingComponent]
                },] },
    ];
    return FndModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Representa um componente para aceitar o redirecionamento de callback do fluxo de oauth2
 */
var AuthCallbackComponent = /** @class */ (function () {
    /**
     *Creates an instance of AuthCallbackComponent.
     * @param {Router} router
     * @param {ActivatedRoute} activatedRoute
     * @param {AuthBaseService} authService
     * @memberof AuthCallbackComponent
     */
    function AuthCallbackComponent(router$$1, authService) {
        var _this = this;
        this.router = router$$1;
        this.authService = authService;
        this.router.events.forEach((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof router.NavigationEnd) {
                _this.authService
                    .completeAuthentication()
                    .then((/**
                 * @return {?}
                 */
                function () {
                    _this.authService
                        .getUser()
                        .then((/**
                     * @param {?} user
                     * @return {?}
                     */
                    function (user) {
                        _this.authService.userLoadedEvent.emit(user);
                    }));
                }));
            }
        }));
    }
    /**
     * @return {?}
     */
    AuthCallbackComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    AuthCallbackComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'app-auth-callback',
                    template: ''
                },] },
    ];
    /** @nocollapse */
    AuthCallbackComponent.ctorParameters = function () { return [
        { type: router.Router },
        { type: baseFoundation.AuthBaseService }
    ]; };
    return AuthCallbackComponent;
}());

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Implementação de guard com uso do serviço de autenticação padrão
 */
var AuthGuard = /** @class */ (function () {
    /**
     *Creates an instance of AuthGuard.
     * @param authService
     */
    function AuthGuard(authService) {
        this.authService = authService;
    }
    /**
     * Implementação do serviço angular que previne o carregamento de componentes, se necessário
     */
    /**
     * Implementação do serviço angular que previne o carregamento de componentes, se necessário
     * @return {?}
     */
    AuthGuard.prototype.canActivate = /**
     * Implementação do serviço angular que previne o carregamento de componentes, se necessário
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var isAuthorized, user;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.authService.authorize()];
                    case 1:
                        isAuthorized = _a.sent();
                        if (!isAuthorized) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.authService.getUser()];
                    case 2:
                        user = _a.sent();
                        this.authService.userLoadedEvent.next(user);
                        _a.label = 3;
                    case 3: return [2 /*return*/, isAuthorized];
                }
            });
        });
    };
    AuthGuard.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    AuthGuard.ctorParameters = function () { return [
        { type: baseFoundation.AuthBaseService }
    ]; };
    return AuthGuard;
}());

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter$1 = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator$1 = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AuthService = /** @class */ (function (_super) {
    __extends$3(AuthService, _super);
    /**
     * Método construtor da classe
     * @param authSettings Token de injeção com as configurações de autenticação
     * @param authType Token de injeção com o tipo de autenticação
     */
    function AuthService(authSettings, authType) {
        var _this = _super.call(this, AuthService.AddOriginUrls(authSettings)) || this;
        _this.authSettings = authSettings;
        _this.authType = authType;
        if (_this.authSettings === undefined) {
            throw new baseFoundation.CriticalError('authSettings: undefined');
        }
        if (_this.authType === undefined) {
            throw new baseFoundation.CriticalError('authType: undefined');
        }
        return _this;
    }
    /**
     * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
     * Isso é para permitir que o navegador identifique o domínio de redirecionamento
     * utilizando o caminho relativo
     *
     * @param authSettings as configurações de autenticação
     * @returns as configurações de autenticação com uris normalizadas para o processo de autenticação
     */
    /**
     * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
     * Isso é para permitir que o navegador identifique o domínio de redirecionamento
     * utilizando o caminho relativo
     *
     * @param {?} authSettings as configurações de autenticação
     * @return {?} as configurações de autenticação com uris normalizadas para o processo de autenticação
     */
    AuthService.AddOriginUrls = /**
     * Adiciona nas uris de redirecionamento do processo oauth o host de origem, se um host não for informado
     * Isso é para permitir que o navegador identifique o domínio de redirecionamento
     * utilizando o caminho relativo
     *
     * @param {?} authSettings as configurações de autenticação
     * @return {?} as configurações de autenticação com uris normalizadas para o processo de autenticação
     */
    function (authSettings) {
        if (authSettings) {
            authSettings.redirect_uri = AuthService.AddOriginUrl(window.location.origin, authSettings.redirect_uri);
            authSettings.post_logout_redirect_uri
                = AuthService.AddOriginUrl(window.location.origin, authSettings.post_logout_redirect_uri);
            authSettings.silent_redirect_uri = AuthService.AddOriginUrl(window.location.origin, authSettings.silent_redirect_uri);
            if (!authSettings.post_logout_redirect_uri) {
                authSettings.post_logout_redirect_uri = window.location.origin;
            }
        }
        return authSettings;
    };
    /**
     * Adiciona o host na url, se nenhum host estiver presente
     * @param host o host a ser adicionado
     * @param url url em que o host será adicionado
     * @returns a junção da url e host
     */
    /**
     * Adiciona o host na url, se nenhum host estiver presente
     * @param {?} host o host a ser adicionado
     * @param {?} url url em que o host será adicionado
     * @return {?} a junção da url e host
     */
    AuthService.AddOriginUrl = /**
     * Adiciona o host na url, se nenhum host estiver presente
     * @param {?} host o host a ser adicionado
     * @param {?} url url em que o host será adicionado
     * @return {?} a junção da url e host
     */
    function (host, url) {
        if (url.trim().length !== 0 && !url.startsWith(host) && !url.startsWith('http')) {
            url = "" + host + url;
        }
        return url;
    };
    /**
     * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
     */
    /**
     * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
     * @param {?} router
     * @return {?}
     */
    AuthService.prototype.shouldShowMenu = /**
     * Verifica se está em atuação o fluxo de login e deveria ou não mostrar o menu
     * @param {?} router
     * @return {?}
     */
    function (router$$1) {
        /** @type {?} */
        var loginFlow = false;
        router$$1.events.forEach((/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event instanceof router.NavigationStart) {
                loginFlow = event.url === '' || event.url === '/' || event.url.startsWith('/auth-callback');
                // vai redirecionar, guarda a rota atual
                if (!loginFlow) {
                    localStorage.setItem('current.route', event.url);
                }
            }
        }));
        return loginFlow;
    };
    /**
     * Monta um ThfToolbarProfile a partir do usuário. Sem suporte a avatar no momento
     */
    /**
     * Monta um ThfToolbarProfile a partir do usuário. Sem suporte a avatar no momento
     * @param {?} user
     * @return {?}
     */
    AuthService.prototype.getToolbarProfile = /**
     * Monta um ThfToolbarProfile a partir do usuário. Sem suporte a avatar no momento
     * @param {?} user
     * @return {?}
     */
    function (user) {
        return {
            title: user && user.profile ? user.profile.name : null,
            subtitle: user && user.profile ? user.profile.email : null
        };
    };
    /**
     * Método responsável executar o processo de login/autenticação
     */
    /**
     * Método responsável executar o processo de login/autenticação
     * @return {?}
     */
    AuthService.prototype.loginFlow = /**
     * Método responsável executar o processo de login/autenticação
     * @return {?}
     */
    function () {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.authType.type === baseFoundation.AuthHandlerType.oauth2)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.signinRedirect()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Método responsável executar o processo de logout
     */
    /**
     * Método responsável executar o processo de logout
     * @return {?}
     */
    AuthService.prototype.logoutFlow = /**
     * Método responsável executar o processo de logout
     * @return {?}
     */
    function () {
        return __awaiter$1(this, void 0, void 0, function () {
            return __generator$1(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this.authType.type === baseFoundation.AuthHandlerType.oauth2)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.signoutRedirect()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    AuthService.decorators = [
        { type: core.Injectable },
    ];
    /** @nocollapse */
    AuthService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Inject, args: [baseFoundation.AUTH_SETTINGS,] }] },
        { type: undefined, decorators: [{ type: core.Inject, args: [baseFoundation.AUTH_TYPE,] }] }
    ]; };
    return AuthService;
}(baseFoundation.AuthBaseService));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Módulo que exporta e ativas as dependências para utilizar autenticação com fluxo oauth2
 * Para garantir que os serviços tenham uma única instância, usar AuthModule.forRoot() ao importar
 * @export
 */
var AuthModule = /** @class */ (function () {
    function AuthModule() {
    }
    /**
     * @return {?}
     */
    AuthModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: AuthModule,
            providers: [
                AuthService,
                baseFoundation.UserPermissionService,
                {
                    provide: baseFoundation.AuthBaseService,
                    useClass: AuthService
                },
                AuthGuard
            ]
        };
    };
    AuthModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [],
                    exports: [],
                    entryComponents: [],
                    providers: [
                        {
                            provide: http.HTTP_INTERCEPTORS,
                            useClass: baseFoundation.AuthInterceptorHandlerService,
                            multi: true
                        }
                    ],
                    declarations: [AuthCallbackComponent]
                },] },
    ];
    return AuthModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

exports.FndModule = FndModule;
exports.AuthCallbackComponent = AuthCallbackComponent;
exports.AuthGuard = AuthGuard;
exports.AuthModule = AuthModule;
exports.AuthService = AuthService;
exports.DateTimeModule = DateTimeModule;
exports.GlobalService = GlobalService;
exports.IntlLiteralsLoaderService = IntlLiteralsLoaderService;
exports.IntlModule = IntlModule;
exports.INTL_CONFIG = INTL_CONFIG;
exports.IntlService = IntlService;
exports.MessageComponent = MessageComponent;
exports.MessageService = MessageService;
exports.MessageModule = MessageModule;
exports.LoadingComponent = LoadingComponent;
exports.LoadingService = LoadingService;
exports.LoadingModule = LoadingModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
