import { InjectionToken } from '@angular/core';
import { ThfI18nConfig } from '@totvs/thf-ui/services/thf-i18n';
import { I18nBaseService } from 'base-foundation';
import { IIntlConfig } from './intl-config.interface';
import { IntlLiteralsLoaderService } from './intl-literal-loader.service';
/**
 * Token de configuração da url de internacionalização
 */
export declare const INTL_CONFIG: InjectionToken<IIntlConfig>;
/**
 * Serviço de internacionalização
 * @extends I18nBaseService
 */
export declare class IntlService extends I18nBaseService {
    /**
     * Atributo com as configurações de internacionalização
     */
    static i18nConfig: ThfI18nConfig;
    /**
     * Método construtor da classe
     * @param config Parâmetro do serviço com as configurações de internacionalização
     * @param intlLiteralsLoader Parâmetro do serviço de carregamento de literais de internacionalização
     */
    constructor(config: IIntlConfig, intlLiteralsLoader: IntlLiteralsLoaderService);
}
